package CBAIS::Actions::ActionFactory;

# $Id: ActionFactory.pm,v 1.5 2001/06/22 07:20:58 mos Exp $
#
use Data::Dumper;

use CBAIS::Config::CBAIS;

require CBAIS::Actions::Action;
require CBAIS::Actions::Append;
require CBAIS::Actions::Cmd;
require CBAIS::Actions::Cchmod;
require CBAIS::Actions::Mkdir;
require CBAIS::Actions::Copy;
require CBAIS::Actions::Pkg;
require CBAIS::Actions::Reboot;

require CBAIS::Actions::Rm;
# this should change .. but for now we will only include of this var
if ($^O eq 'linux' || defined($ENV{CBAIS_ENABLE_RPM}))
{
    require CBAIS::Actions::Rpm;
}
require CBAIS::Actions::Symlink;
require CBAIS::Actions::TextAction;


sub new
{
    my ($tracer) = new Util::Tracer(@_);
    my ($class) = shift;
    my ($this) = {
        @_,
        # 'CBAIS_CONFIG' => getCBAISConfig(),
    };

    bless ($this, $class);
    return $this;
}

sub createTitleAction
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this, $cbais_class) = @_;
    my (%title_conf) = (TEXT => "Class $cbais_class " .
                        '===================================================',
                        CLASS=> $cbais_class);
    return new CBAIS::Actions::TextAction(%title_conf);
}

# takes a list of action configurations and returns  alist of action objects
# to implement them.
sub create
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this, $conf) = @_;
    my ($class, $action);

    $tracer->print("Attempting to create action from " . Dumper($conf));
    if (! defined($conf->{ACTION}))
    {
        print STDERR "Invalid action config - " . Dumper($conf) . "\n";
        print STDERR "ACTION keyword must be defined!";
        return 0;
    }
    else
    {
        $class = $this->{CBAIS_CONFIG}->getActionPackage($conf->{ACTION});
        if (! $class)
        {
            $class = 'CBAIS::Actions::Action';
            print STDERR "No package configured to implement action " .
                "$conf->{ACTION} - using $class as placeholder\n";
        }
        $tracer->print("about to do new $class " . %{$conf});
        $conf->{CBAIS_CONFIG} = $this->{CBAIS_CONFIG};
        $conf->{FILE_LOCATOR} = $this->{FILE_LOCATOR};
        
        $action = $class->new(%{$conf});
        $tracer->print('created action ' . $action->toString());
    }
    return $action;
    
}
