package CBAIS::Actions::MOGAction;

# An Action which will involve setting Mode, Owner and Group
# yes sad name

###############################################
use Carp;

require Util::Tracer;

# use CBAIS::Util::UIDCache;

use base("CBAIS::Actions::FileHolder");

#
#####################################################
sub new
{
    my ($tracer) = new Util::Tracer(@_);
    my ($class) = shift;
    my ($this) = new CBAIS::Actions::FileHolder(@_);
    
    croak "Missing required keys from hash"
        unless $this->check_keys('OWNER', 'GROUP', 'MODE');

    # $this->{'MODE_STR'} = $this->{MODE};
    # $this->{'MODE'} = oct $this->{MODE};
    # $this->{'UID'} = getUID($this->{OWNER});
    # $this->{'GID'} = getGID($this->{GROUP});
    bless($this, $class);
    return $this;
}

=head2 chown_and_chmod file

Set the ownership and permissions of a file. The mode, owner and group are
configured when object is created. Returns 1 on success else 0;

=cut

sub chown_and_chmod
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this, $file) = @_;
    if (chmod($this->{MODE}, $file) && chown($this->{UID}, $this->{GID}, $file))
    {
        return 1;
    }
    else
    {
        $this->{ERROR_MESSAGE} =
            "cchmod $file, $this->{MODE}, $this->{UID}, $this->{GID} failed : $!\n";
        return 0;
    }
}

sub verify
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this, $file) = @_;

    my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
        $atime,$mtime,$ctime,$blksize,$blocks) = stat($file);

    $mode = $mode & 07777;
    if ($uid != $this->{UID})
    {
        $this->{ERROR_MESSAGE}  = "$file.UID: $uid != $this->{UID}";
        $tracer->print("UID: $uid != $this->{UID}");
        return 0;
    }
    if ($gid != $this->{GID})
    {
        $this->{ERROR_MESSAGE}  = "$file.GID: $gid != $this->{GID}";
        $tracer->print("GID: $gid != $this->{GID}");
        return 0;
    }
    if ($mode != $this->{MODE})
    {
        $this->{ERROR_MESSAGE}  ="$file.MODE: $mode != $this->{MODE}";
        $tracer->print("MODE: $mode != $this->{MODE} ($this->{MODE_STR})");
        return 0;
    }
    return 1;
}

1;
