package CBAIS::Actions::Reboot;

=head1 NAME

CBAIS::Actions::Reboot - reboot a host during install

=head1 SYNOPSIS

$reboot = new CBAIS::Actions::Reboot(SPOOL_DIR => '/etc/cbais');

$reboot->execute(@remaining_actions);

=head1 DESCRIPTION

The B<CBAIS::Actions::Reboot> class implements a CBAIS action which is used
to trigger a reboot during an installation.

=head1 METHODS

=head2 new

The constructor. The following hash keys are required to be passed.

=over 4

=item B<SPOOL_DIR>

the file to append to e.g. /etc/system.

=item B<HOST_CONFIG>

the CBAIS host config object for this host. Used to get the OS specific
reboot command.

=back

=cut



require Util::Tracer;

use base("CBAIS::Actions::Action");

sub new
{
    my ($tracer) = new Util::Tracer(@_);
    my ($class) = shift;
    my ($this) = new CBAIS::Actions::Action(@_);
    bless($this, $class);
    return $this;
}

sub execute
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this) = shift;
    return 1;
}

sub toString
{
    return "<************************* REBOOT <*************************>";
}
