package CBAIS::Actions::FileHolder;

=head1 NAME

CBAIS::Actions::FileHolder - serialiase data for CBAIS actions

=head1 SYNOPSIS


=head1 DESCRIPTION

The B<CBAIS::Actions::FileHolder> class is an aaabstract class which
implements a pattern for serialising the data associated with a CBAIS action
along with its config.

=cut

use base("CBAIS::Actions::Action");

sub new
{
    my ($tracer) = new Util::Tracer(@_);
    my ($class) = shift;
    my ($this) = new CBAIS::Actions::Action(@_);

    $this->{FILE_HOLDER} = new CBAIS::Util::FileHolder();
    bless($this, $class);
    return $this; 
}


sub setHolderFile
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this) = shift;
    $this->{FILE_HOLDER}->setFile(shift);
}

sub serialiseData
{
    my ($tracer) = new Util::Tracer(@_); 
    my ($this) = shift;

    if (! $this->{FILE_HOLDER}->isLoaded())
    {
        $this->{FILE_HOLDER}->load();
    }
    $this->{FILE_HOLDER}->encode();
    return $this->SUPER::serialise();
}

1;
