package CBAIS::CBAIS;

# Holder for any globals we use
use Carp;

require Exporter;



use Util::Tracer;

our @ISA = qw(Exporter);

our @EXPORT = qw($WARNING $ERROR parse_command_str);

*WARNING = \"WARNING :";
*ERROR   = \"ERROR   :";

# return an array of commands
sub parse_command_str
{
    my ($tracer) = new Util::Tracer(@_);

    my (@commands) = split(',', shift);
    foreach $command (@commands)
    {
        $tracer->print("processing command $command");
        if ($command =~ m/^ex/i)
        {
            $command = 'execute';
        }
        elsif ($command =~ m/^c/i)
        {
            $command = 'check';
        }
        elsif ($command =~ m/^s/i)
        {
            $command = 'show';
        }
        elsif ($command =~ m/^u/i)
        {
            $command = 'undo';  
            
        }
        elsif ($command =~ m/^v/i)
        {
            $command = 'verify';  
        }
        else
        {
            croak "invalid command specified ($command)";
        }
    }
    return @commands;
}
# 
