package CBAIS::Config::KickStart;

=head1 NAME

CBAIS::Config::Kickstart - default kickstart values and conf file generation utilities

=head1 DESCRIPTION

=cut

use Carp;

use Util::Tracer;

use CBAIS::CBAIS;
use CBAIS::Config::CBAIS;
use CBAIS::Config::Host;

use CBAIS::Path::FileLocator;

sub new
{
    my ($tracer) = new Util::Tracer(@_);
    my ($class) = shift;
    my ($conf_file);
    my ($this) = {};

    if (@_)
    {
        $conf_file = shift;
        my ($conf) = eval "require \'$conf_file\'";
        
        if ($@)
        {
            warn "Unable to load $conf_file (continuing anyway): $@";
            $this->{CONFIG}= {};
        }
        else
        {
            $this->{CONFIG} = $conf;
            $tracer->print("Loaded  $conf_file");
        }
    }
    
    bless($this, $class);
    return $this;
}

sub get
{
    my ($tracer) = new Util::Tracer(@_);
    my ($this) = shift;
    my ($key);
    my (@results);
    my ($undefined) = 0;
    
    foreach $key (@_)
    {
        if (defined($this->{CONFIG}->{$key}))
        {
            push(@results, $this->{CONFIG}->{$key});
        }
        else
        {
            $tracer->print("$key is not defined in KickStart.conf");
            push(@results, "unset");
            $undefined++;
        }
    }
    print STDERR "$WARNING $undefined undefined keys returned\n" if $undefined;
    return @results;
}

1;
