package CBAIS::MD::Utils;

=head1 NAME

B<CBAIS::MD::Utils> - Meta Device (disk) utility methods.

=cut

use Exporter;


@ISA = qw( Exporter );

@EXPORT = qw( parse_disk_spec parse_metadevice_type );


=item expand_a_dash() range, letter

range - the range to expand (of the form digit-digit, e.g. 3-5.)
letter - the section of a disk device to expand , one of c,t,d,s for scsi
devics or hddisks. 
                            

=cut



sub expand_a_dash
{
    my ($range,$letter) = @_;
    # print "Got Range = $range\n";
    my (@expanded);
    my ($i);
    my ($first,$last) = split('-', $range);
    
    for ($i = $first; $i <= $last; $i++)
    {
        push(@expanded,"${letter}${i}");
    }
    return (@expanded);
}


=item B<expand_commas> (range, letter)

range  - a range to expand, of form \d[-\d],\d[-\d].
letter - the section of a disk device to expand , one of c,t,d or s.

Note that individual items which contain underscores will be expanded in place.


=cut

sub expand_commas
{
    my ($range,$letter) = @_;
    my (@expanded);
    my (@entries) = split(',',$range);
    foreach $entry (@entries)
    {
        if ($entry =~ /-/)
        {
            # print "Calling expand_a_dash($entry,$letter)\n";
            push(@expanded, expand_a_dash($entry,$letter));
        }
        else
        {
            push(@expanded,"$letter$entry");
        }
    }
    return (@expanded);
}

